<!--
 * @Description:It is troublesome to implement radio button group in the form. So it is extracted independently as a separate component
-->
<template>
  <RadioGroup
    v-bind="attrs"
    v-model:value="checked"
    button-style="solid"
    @change="handleChange"
    :style="{
      display: 'flex',
      flexDirection: 'column',
    }"
  >
    <template v-for="(item, idx) in getOptions" :key="`${item.value}`">
      <Radio :value="item.value" :disabled="item.disabled">
        <div class="radio-box">
          <span class="select-box">{{ alphabet[idx] }}</span>
          <span>{{ item.label }}</span>
        </div>
      </Radio>
    </template>
  </RadioGroup>
</template>
<script lang="ts">
  import { defineComponent, PropType, ref, computed, unref, watch, inject, watchEffect } from 'vue';
  import { Radio } from 'ant-design-vue';
  import { isFunction } from '/@/utils/is';
  import { useAttrs } from '/@/hooks/core/useAttrs';
  import { propTypes } from '/@/utils/propTypes';
  import { get, omit } from 'lodash-es';
  import { useI18n } from '/@/hooks/web/useI18n';
  import { getDicDetailList } from '/@/api/system/dic';
  import { getDatasourceData } from '/@/api/system/datasource';
  import { apiConfigFunc, camelCaseString, isValidJSON, alphabet } from '/@/utils/event/design';

  type OptionsItem = { label: string; value: string | number | boolean; disabled?: boolean };

  export default defineComponent({
    name: 'ApiRadioGroup',
    components: {
      RadioGroup: Radio.Group,
      Radio,
    },
    props: {
      api: {
        type: Function as PropType<(arg?: Recordable | string) => Promise<OptionsItem[]>>,
        default: null,
      },
      params: {
        type: [Object, String] as PropType<Recordable | string>,
        default: () => ({}),
      },
      value: {
        type: [String, Number, Boolean] as PropType<string | number | boolean>,
      },
      isBtn: {
        type: [Boolean] as PropType<boolean>,
        default: false,
      },
      numberToString: propTypes.bool,
      resultField: propTypes.string.def(''),
      labelField: propTypes.string.def('label'),
      valueField: propTypes.string.def('value'),
      immediate: propTypes.bool.def(true),
      //数据来源 默认为空  如果不为空 则参数 api
      datasourceType: String,
      optionType: propTypes.string.def('default'),
      staticOptions: {
        type: Array as PropType<OptionsItem[]>,
        default: () => [],
      },
      apiConfig: Object,
      mainKey: String,
      index: Number,
    },
    emits: ['options-change', 'change', 'update:value'],
    setup(props, { emit }) {
      const options = ref<OptionsItem[]>([]);
      const loading = ref(false);
      const attrs = useAttrs();
      const { t } = useI18n();
      const formModel = inject<any>('formModel', null);
      const isCamelCase = inject<boolean>('isCamelCase', false);
      // Embedded in the form, just use the hook binding to perform form verification
      const checked = ref<string | number>('');
      // Processing options value
      const getOptions = computed(() => {
        const { labelField, valueField, numberToString } = props;
        return unref(options).reduce((prev, next: Recordable) => {
          if (next) {
            const value = next[valueField];
            prev.push({
              label: next[labelField],
              value: numberToString ? `${value}` : value,
              ...omit(next, [labelField, valueField]),
            });
          }
          return prev;
        }, [] as OptionsItem[]);
      });
      watchEffect(() => {
        if (props.datasourceType === 'api' && props.apiConfig?.apiParams) {
          props.apiConfig.apiParams.forEach((params) => {
            params.tableInfo?.forEach((o) => {
              if (o.bindType == 'data') {
                let val = isValidJSON(o.value);
                let field = '';
                if (val && val.bindTable) {
                  let table = !isCamelCase
                    ? val.bindTable + 'List'
                    : camelCaseString(val.bindTable + '_List');
                  field = !isCamelCase ? val.bindField : camelCaseString(val.bindField);

                  formModel &&
                    formModel[table!][props.index || 0] &&
                    formModel[table!][props.index || 0][field];
                } else if (val && val.bindField) {
                  field = !isCamelCase ? val.bindField : camelCaseString(val.bindField);
                  formModel && formModel[field];
                }
              }
            });
          });
          fetch();
        }
      });
      watch(
        () => [props.params, props.datasourceType, props.apiConfig],
        () => {
          fetch();
        },
        { deep: true, immediate: true },
      );

      watch(
        () => props.value,
        (val: any) => {
          checked.value = val;
        },
        {
          immediate: true,
        },
      );

      async function fetch() {
        let api;
        if (props.datasourceType) {
          if (props.datasourceType === 'dic') {
            api = getDicDetailList;
          }
          if (props.datasourceType === 'datasource') {
            api = getDatasourceData;
          }
          if (props.datasourceType === 'staticData') {
            options.value = props.staticOptions;
          }
          if (props.datasourceType === 'api') {
            options.value = await apiConfigFunc(
              props.apiConfig,
              isCamelCase,
              formModel,
              props.index,
            );
          }
        } else {
          api = props.api;
        }
        if (!api || !isFunction(api)) return;
        options.value = [];
        try {
          if (!props.params) return;
          loading.value = true;
          const res = await api(props.params);
          if (Array.isArray(res)) {
            options.value = res;
            emitChange();
            return;
          }
          if (props.resultField) {
            options.value = get(res, props.resultField) || [];
          }
          emitChange();
        } catch (error) {
          console.warn(error);
        } finally {
          loading.value = false;
        }
      }

      function emitChange() {
        emit('options-change', unref(getOptions));
      }

      function handleChange({ target }) {
        emit('update:value', target.value);
        emit('change');
      }

      return { checked, getOptions, attrs, loading, t, handleChange, props, alphabet };
    },
  });
</script>
<style lang="less" scoped>
  :deep(.ant-radio) {
    display: none;
  }

  :deep(.ant-radio-wrapper) {
    margin-bottom: 20px;
  }

  .radio-box {
    display: flex;
    align-items: center;

    .select-box {
      display: flex;
      justify-content: center;
      align-items: center;
      border: 1px solid #ccc;
      width: 25px;
      height: 25px;
      border-radius: 50%;
      margin-right: 15px;
    }
  }

  :deep(.ant-radio-wrapper-checked) {
    .select-box {
      border-color: #5e95ff;
      background: #5e95ff;
      color: #fff;
    }
  }
</style>
